


typedef struct triangle
{
    vertex v1, v2, v3;

    triangle *next;
};
    



// Quadtree class
class quadtree
{

  public:

    quadtree(void) {};    
    ~quadtree();
    
    quadtree(double nmin_x, double nmin_y,  double nmax_x, double nmax_y, int l);
    
    void dump ( int level );    
    
    bool render( void );

    double min_x, max_x;
    double min_y, max_y;
   
    bool is_leaf;
    
    int level;
    
    quadtree *nodes[4];
};




class terrain_class
{

    friend class quadtree;

    public:
    terrain_class(void);
    
    void render( void );

    void setup ( void );
       
    triangle *t_list;
    
    unsigned int num_triangles;
    
    
   quadtree *main_tree;         // Main tree for testing
 
};





